/**
*	This file removes downloaded files older than 1 day.
*/

Components.utils.import("resource://gre/modules/osfile.jsm");

var openDownloadCleanup = {
	loaded: false,
	init: function() {
		var prefs = Components.classes['@mozilla.org/preferences-service;1'].getService(Components.interfaces.nsIPrefBranch);

		if (!openDownloadCleanup.loaded) {
			// Start delayed after opening the browser
			var timeout = 6000; // 6 seconds
			if (prefs.getPrefType("dom.min_timeout_value") == 64)
				// Gecko 2.0 - overwrite it with the new recommended prefs value :)
				timeout = prefs.getIntPref("dom.min_timeout_value");
			
			setTimeout("openDownloadCleanup.cleanup()", timeout);
			openDownloadCleanup.loaded = true;
		}
	},

	cleanup: function() {
		try {
			var iYesterday = (new Date()).getTime() - (1000 * 60 * 60 * 24);
			var oDir = null;

			oDir = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsIFile);
		
			// read the extensions.openDownload2.downloadPath.
			// if we have it, use it. if not, don't.
			var prefService = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
			var prefServiceBranch = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("");
			
			if (prefServiceBranch.getPrefType('extensions.openDownload2.downloadPath')) {
				// key exists! use the user-defined dir.
				var prefs = prefService.getBranch("extensions.openDownload2.");
				var sTmp  = prefs.getCharPref("downloadPath"); // get the pref

				// Read Directory
				// Note: this will throw NS_ERROR_FILE_UNRECOGNIZED_PATH if the path is invalid (which
				//       shouldn't happen anymore, but who knows...). Should be caught by the error
				//       handling below all this here,
				oDir.initWithPath(sTmp);
			}
			else {
				// nah, let's use the default dir.
				var sTmp = OS.Path.join(OS.Constants.Path.tmpDir,"mozOpenDownload");

				// Read Directory
				// Note: this should exist anyway if there's anything to clean up... yadda...
				oDir.initWithPath(sTmp);
			}
				
			if (oDir.isDirectory()) {
				var aFiles 	= oDir.directoryEntries;
				var oFile	= null;
				while (aFiles.hasMoreElements()) {
					try {
						oFile = aFiles.getNext().QueryInterface(Components.interfaces.nsIFile);
						
						// Remove
						if (oFile.lastModifiedTime <= iYesterday)
							oFile.remove(true);
					} catch(e) { }
				}
			}	
		} catch(e){ }
	}
}