// Init Dialog
var openDownloadOverlayD = {
	_bundle: Components.classes["@mozilla.org/intl/stringbundle;1"].getService(Components.interfaces.nsIStringBundleService).createBundle("chrome://opendownload/locale/opendownload.properties"),

	init: function() {
		// Set OnDialogAccept Handler
		try {
			var oDialog = document.getElementById("unknownContentType");
			oDialog.setAttribute("ondialogaccept", "if (openDownloadMain.openDownload()) return true;" + oDialog.getAttribute("ondialogaccept"));
		}
		catch(e) {
			Components.utils.reportError("OpenDownload (001)\n" + openDownloadOverlayD._bundle.GetStringFromName("error.init.process") + "\n"+ e);
			document.getElementById('open-download').disabled = true;
		}
		
		document.getElementById('rememberChoice').setAttribute("disabled", false);
		document.getElementById('mode').addEventListener("RadioStateChange", openDownloadOverlayD.toggleCheckbox, true);
		document.getElementById('open-download').setAttribute("label", openDownloadOverlayD._bundle.formatStringFromName("label.openwithdefaultapp", [navigator.platform], 1));

	 	var mimeType = null;
	 	
	 	try {
	 		var mimeService = Components.classes["@mozilla.org/mime;1"].getService(Components.interfaces.nsIMIMEService);
		 	mimeType = mimeService.getTypeFromURI(dialog.mLauncher.source);
		}
		catch (e) {
			/* whoops ... */
			mimeType = dialog.mLauncher.MIMEInfo.MIMEType;
		}

		// Determine if we have an executable file here:
	    if (
		    document.getElementById("normalBox").collapsed                                /* Fx < 3.5 */  ||
	    	(document.getElementById("open") && document.getElementById("open").disabled) /* Fx >= 3.5 */ ||

	    	/* Firefox 6.0+ */
	    	// I -like- it when people invent their own MIME types! (x-exe, x-dosexec, x-whatever...)
	    	// So - drop them. Use the "type" text box or the MIME types where applicable.
	    	mimeType == "application/x-msi"        ||
	    	mimeType == "application/octet-stream" ||
	    	mimeType == "application/x-msdownload" ||
	    	/* mimeType == "unknown/unknown" || */ /* NOTE: I know this is a dangerous option, but I am positive
	    									          that files without a "known" MIME type are executable
	    									          files. The only web server with "unknown" MIME types I
	    									          have stumbled upon is Piriform.com, providing executable
	    									          downloads only. (With rather confusing redirects, that is.)

	    									          NOTE, March 2013: Late Tux does not like what early Tux did
	    									          here. Also, piriform.com has sane MIME Types now.
	    									       */

	    	// ref.: http://mxr.mozilla.org/mozilla-central/source/uriloader/exthandler/nsExternalHelperAppService.cpp
	    	document.getElementById("type").value == "Binary File"
	    )
	    {
			// Add 'Run' button
			var cancelBtn = document.documentElement.getButton("accept");
			var btn = document.createElement("button");
			btn.setAttribute("class", "dialog-button");
			btn.setAttribute("label", openDownloadOverlayD._bundle.GetStringFromName("label.runbutton"));
			btn.setAttribute("oncommand","openDownloadOverlayD.runBtn()");
			btn.setAttribute("id", "run-button");
			btn.setAttribute("disabled", cancelBtn.getAttribute("disabled"));
			cancelBtn.watch("disabled", openDownloadOverlayD.updateButton);
			cancelBtn.parentNode.insertBefore(btn, cancelBtn);
			document.getElementById('open-download').hidden = true;
	    }
		else {
			document.getElementById('open-download').hidden = false;
		}
	},

	// When Save button is disabled, disable run button
	updateButton: function(id, oldVal, newVal) {
		// When Firefox's Save button's disable attribute changes, copy it
		if (id == "disabled")
			document.getElementById("run-button").setAttribute("disabled", newVal);
		
		// Must return newVal otherwise Firefox's save button won't update
		return newVal;
	},

	// Envoke the 'Run' button action
	runBtn: function(){
		document.getElementById("mode").selectedItem = document.getElementById('open-download');
		document.documentElement.getButton("accept").doCommand();
	},

	// Toggle "Do this automatically" checkbox
	toggleCheckbox: function(){
		if (document.getElementById('open-download').selected)
			document.getElementById('rememberChoice').setAttribute("disabled", true);
		else
			document.getElementById('rememberChoice').setAttribute("disabled", false);
	}
}